diff -urp webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/IntlNumberFormat.cpp webkitgtk-2.32.1/Source/JavaScriptCore/runtime/IntlNumberFormat.cpp
--- webkitgtk-2.32.1.gstreamer/Source/JavaScriptCore/runtime/IntlNumberFormat.cpp	2021-02-26 03:57:05.000000000 -0600
+++ webkitgtk-2.32.1/Source/JavaScriptCore/runtime/IntlNumberFormat.cpp	2021-05-22 16:00:30.670479300 -0500
@@ -42,7 +42,7 @@ namespace JSC {
 const ClassInfo IntlNumberFormat::s_info = { "Object", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(IntlNumberFormat) };
 
 namespace IntlNumberFormatInternal {
-static constexpr bool verbose = false;
+constexpr bool verbose = false;
 }
 
 struct IntlNumberFormatField {
@@ -50,6 +50,12 @@ struct IntlNumberFormatField {
     size_t size;
 };
 
+void IntlNumberFormat::UNumberFormatDeleter::operator()(UNumberFormat* numberFormat) const
+{
+    if (numberFormat)
+        unum_close(numberFormat);
+}
+
 IntlNumberFormat* IntlNumberFormat::create(VM& vm, Structure* structure)
 {
     IntlNumberFormat* format = new (NotNull, allocateCell<IntlNumberFormat>(vm.heap)) IntlNumberFormat(vm, structure);
@@ -117,7 +123,7 @@ static unsigned computeCurrencyDigits(co
     // 11.1.1 The abstract operation CurrencyDigits (currency)
     // "If the ISO 4217 currency and funds code list contains currency as an alphabetic code,
     // then return the minor unit value corresponding to the currency from the list; else return 2.
-    static constexpr std::pair<const char*, unsigned> currencyMinorUnits[] = {
+    std::pair<const char*, unsigned> currencyMinorUnits[] = {
         { "BHD", 3 },
         { "BIF", 0 },
         { "BYR", 0 },
@@ -151,120 +157,6 @@ static unsigned computeCurrencyDigits(co
     return 2;
 }
 
-// Create MeasureUnit like ICU4J.
-struct MeasureUnit {
-    ASCIILiteral type;
-    ASCIILiteral subType;
-};
-
-static Optional<MeasureUnit> sanctionedSimpleUnitIdentifier(StringView unitIdentifier)
-{
-    static constexpr MeasureUnit simpleUnits[] = {
-        { "area"_s, "acre"_s },
-        { "digital"_s, "bit"_s },
-        { "digital"_s, "byte"_s },
-        { "temperature"_s, "celsius"_s },
-        { "length"_s, "centimeter"_s },
-        { "duration"_s, "day"_s },
-        { "angle"_s, "degree"_s },
-        { "temperature"_s, "fahrenheit"_s },
-        { "volume"_s, "fluid-ounce"_s },
-        { "length"_s, "foot"_s },
-        { "volume"_s, "gallon"_s },
-        { "digital"_s, "gigabit"_s },
-        { "digital"_s, "gigabyte"_s },
-        { "mass"_s, "gram"_s },
-        { "area"_s, "hectare"_s },
-        { "duration"_s, "hour"_s },
-        { "length"_s, "inch"_s },
-        { "digital"_s, "kilobit"_s },
-        { "digital"_s, "kilobyte"_s },
-        { "mass"_s, "kilogram"_s },
-        { "length"_s, "kilometer"_s },
-        { "volume"_s, "liter"_s },
-        { "digital"_s, "megabit"_s },
-        { "digital"_s, "megabyte"_s },
-        { "length"_s, "meter"_s },
-        { "length"_s, "mile"_s },
-        { "length"_s, "mile-scandinavian"_s },
-        { "volume"_s, "milliliter"_s },
-        { "length"_s, "millimeter"_s },
-        { "duration"_s, "millisecond"_s },
-        { "duration"_s, "minute"_s },
-        { "duration"_s, "month"_s },
-        { "mass"_s, "ounce"_s },
-        { "concentr"_s, "percent"_s },
-        { "digital"_s, "petabyte"_s },
-        { "mass"_s, "pound"_s },
-        { "duration"_s, "second"_s },
-        { "mass"_s, "stone"_s },
-        { "digital"_s, "terabit"_s },
-        { "digital"_s, "terabyte"_s },
-        { "duration"_s, "week"_s },
-        { "length"_s, "yard"_s },
-        { "duration"_s, "year"_s },
-    };
-    ASSERT(
-        std::is_sorted(std::begin(simpleUnits), std::end(simpleUnits),
-            [](const MeasureUnit& a, const MeasureUnit& b) {
-                return WTF::codePointCompare(StringView(a.subType), StringView(b.subType)) < 0;
-            }));
-
-    auto iterator = std::lower_bound(std::begin(simpleUnits), std::end(simpleUnits), unitIdentifier,
-        [](const MeasureUnit& unit, StringView unitIdentifier) {
-            return WTF::codePointCompare(StringView(unit.subType), unitIdentifier) < 0;
-        });
-    if (iterator != std::end(simpleUnits) && iterator->subType == unitIdentifier)
-        return *iterator;
-    return WTF::nullopt;
-}
-
-struct WellFormedUnit {
-public:
-    explicit WellFormedUnit(MeasureUnit numerator)
-        : numerator(numerator)
-    {
-    }
-
-    WellFormedUnit(MeasureUnit numerator, MeasureUnit denominator)
-        : numerator(numerator)
-        , denominator(denominator)
-    {
-    }
-
-    MeasureUnit numerator;
-    Optional<MeasureUnit> denominator;
-};
-
-static Optional<WellFormedUnit> wellFormedUnitIdentifier(StringView unitIdentifier)
-{
-    // https://tc39.es/ecma402/#sec-iswellformedunitidentifier
-    if (auto unit = sanctionedSimpleUnitIdentifier(unitIdentifier))
-        return WellFormedUnit(unit.value());
-
-    // If the substring "-per-" does not occur exactly once in unitIdentifier, then return false.
-    auto per = StringView("-per-"_s);
-    auto position = unitIdentifier.find(per);
-    if (position == WTF::notFound)
-        return WTF::nullopt;
-    if (unitIdentifier.find(per, position + per.length()) != WTF::notFound)
-        return WTF::nullopt;
-
-    // If the result of IsSanctionedSimpleUnitIdentifier(numerator) is false, then return false.
-    auto numerator = unitIdentifier.substring(0, position);
-    auto numeratorUnit = sanctionedSimpleUnitIdentifier(numerator);
-    if (!numeratorUnit)
-        return WTF::nullopt;
-
-    // If the result of IsSanctionedSimpleUnitIdentifier(denominator) is false, then return false.
-    auto denominator = unitIdentifier.substring(position + per.length());
-    auto denominatorUnit = sanctionedSimpleUnitIdentifier(denominator);
-    if (!denominatorUnit)
-        return WTF::nullopt;
-
-    return WellFormedUnit(numeratorUnit.value(), denominatorUnit.value());
-}
-
 // https://tc39.github.io/ecma402/#sec-initializenumberformat
 void IntlNumberFormat::initializeNumberFormat(JSGlobalObject* globalObject, JSValue locales, JSValue optionsValue)
 {
@@ -303,7 +195,7 @@ void IntlNumberFormat::initializeNumberF
 
     m_numberingSystem = resolved.extensions[static_cast<unsigned>(RelevantExtensionKey::Nu)];
 
-    m_style = intlOption<Style>(globalObject, options, vm.propertyNames->style, { { "decimal"_s, Style::Decimal }, { "percent"_s, Style::Percent }, { "currency"_s, Style::Currency }, { "unit"_s, Style::Unit } }, "style must be either \"decimal\", \"percent\", \"currency\", or \"unit\""_s, Style::Decimal);
+    m_style = intlOption<Style>(globalObject, options, vm.propertyNames->style, { { "decimal"_s, Style::Decimal }, { "percent"_s, Style::Percent }, { "currency"_s, Style::Currency } }, "style must be either \"decimal\", \"percent\", or \"currency\""_s, Style::Decimal);
     RETURN_IF_EXCEPTION(scope, void());
 
     String currency = intlStringOption(globalObject, options, Identifier::fromString(vm, "currency"), { }, nullptr, nullptr);
@@ -327,210 +219,51 @@ void IntlNumberFormat::initializeNumberF
         currencyDigits = computeCurrencyDigits(currency);
     }
 
-    m_currencyDisplay = intlOption<CurrencyDisplay>(globalObject, options, Identifier::fromString(vm, "currencyDisplay"), { { "code"_s, CurrencyDisplay::Code }, { "symbol"_s, CurrencyDisplay::Symbol }, { "narrowSymbol"_s, CurrencyDisplay::NarrowSymbol }, { "name"_s, CurrencyDisplay::Name } }, "currencyDisplay must be either \"code\", \"symbol\", or \"name\""_s, CurrencyDisplay::Symbol);
+    m_currencyDisplay = intlOption<CurrencyDisplay>(globalObject, options, Identifier::fromString(vm, "currencyDisplay"), { { "code"_s, CurrencyDisplay::Code }, { "symbol"_s, CurrencyDisplay::Symbol }, { "name"_s, CurrencyDisplay::Name } }, "currencyDisplay must be either \"code\", \"symbol\", or \"name\""_s, CurrencyDisplay::Symbol);
     RETURN_IF_EXCEPTION(scope, void());
 
-    m_currencySign = intlOption<CurrencySign>(globalObject, options, Identifier::fromString(vm, "currencySign"), { { "standard"_s, CurrencySign::Standard }, { "accounting"_s, CurrencySign::Accounting } }, "currencySign must be either \"standard\" or \"accounting\""_s, CurrencySign::Standard);
+    unsigned minimumIntegerDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "minimumIntegerDigits"), 1, 21, 1);
     RETURN_IF_EXCEPTION(scope, void());
+    m_minimumIntegerDigits = minimumIntegerDigits;
 
-    String unit = intlStringOption(globalObject, options, Identifier::fromString(vm, "unit"), { }, nullptr, nullptr);
+    unsigned minimumFractionDigitsDefault = (m_style == Style::Currency) ? currencyDigits : 0;
     RETURN_IF_EXCEPTION(scope, void());
-    Optional<WellFormedUnit> wellFormedUnit;
-    if (!unit.isNull()) {
-        wellFormedUnit = wellFormedUnitIdentifier(unit);
-        if (!wellFormedUnit) {
-            throwRangeError(globalObject, scope, "unit is not a well-formed unit identifier"_s);
-            return;
-        }
-        m_unit = unit;
-    } else if (m_style == Style::Unit) {
-        throwTypeError(globalObject, scope, "unit must be a string"_s);
-        return;
-    }
 
-    m_unitDisplay = intlOption<UnitDisplay>(globalObject, options, Identifier::fromString(vm, "unitDisplay"), { { "short"_s, UnitDisplay::Short }, { "narrow"_s, UnitDisplay::Narrow }, { "long"_s, UnitDisplay::Long } }, "unitDisplay must be either \"short\", \"narrow\", or \"long\""_s, UnitDisplay::Short);
+    unsigned minimumFractionDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "minimumFractionDigits"), 0, 20, minimumFractionDigitsDefault);
     RETURN_IF_EXCEPTION(scope, void());
+    m_minimumFractionDigits = minimumFractionDigits;
 
-    unsigned minimumFractionDigitsDefault = (m_style == Style::Currency) ? currencyDigits : 0;
-    unsigned maximumFractionDigitsDefault = (m_style == Style::Currency) ? currencyDigits : (m_style == Style::Percent) ? 0 : 3;
+    unsigned maximumFractionDigitsDefault;
+    if (m_style == Style::Currency)
+        maximumFractionDigitsDefault = std::max(minimumFractionDigits, currencyDigits);
+    else if (m_style == Style::Percent)
+        maximumFractionDigitsDefault = minimumFractionDigits;
+    else
+        maximumFractionDigitsDefault = std::max(minimumFractionDigits, 3u);
 
-    m_notation = intlOption<IntlNotation>(globalObject, options, Identifier::fromString(vm, "notation"), { { "standard"_s, IntlNotation::Standard }, { "scientific"_s, IntlNotation::Scientific }, { "engineering"_s, IntlNotation::Engineering }, { "compact"_s, IntlNotation::Compact } }, "notation must be either \"standard\", \"scientific\", \"engineering\", or \"compact\""_s, IntlNotation::Standard);
+    unsigned maximumFractionDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "maximumFractionDigits"), minimumFractionDigits, 20, maximumFractionDigitsDefault);
     RETURN_IF_EXCEPTION(scope, void());
+    m_maximumFractionDigits = maximumFractionDigits;
 
-    setNumberFormatDigitOptions(globalObject, this, options, minimumFractionDigitsDefault, maximumFractionDigitsDefault, m_notation);
+    JSValue minimumSignificantDigitsValue = options->get(globalObject, Identifier::fromString(vm, "minimumSignificantDigits"));
     RETURN_IF_EXCEPTION(scope, void());
 
-    m_compactDisplay = intlOption<CompactDisplay>(globalObject, options, Identifier::fromString(vm, "compactDisplay"), { { "short"_s, CompactDisplay::Short }, { "long"_s, CompactDisplay::Long } }, "compactDisplay must be either \"short\" or \"long\""_s, CompactDisplay::Short);
+    JSValue maximumSignificantDigitsValue = options->get(globalObject, Identifier::fromString(vm, "maximumSignificantDigits"));
     RETURN_IF_EXCEPTION(scope, void());
 
+    if (!minimumSignificantDigitsValue.isUndefined() || !maximumSignificantDigitsValue.isUndefined()) {
+        unsigned minimumSignificantDigits = intlDefaultNumberOption(globalObject, minimumSignificantDigitsValue, Identifier::fromString(vm, "minimumSignificantDigits"), 1, 21, 1);
+        RETURN_IF_EXCEPTION(scope, void());
+        unsigned maximumSignificantDigits = intlDefaultNumberOption(globalObject, maximumSignificantDigitsValue, Identifier::fromString(vm, "maximumSignificantDigits"), minimumSignificantDigits, 21, 21);
+        RETURN_IF_EXCEPTION(scope, void());
+        m_minimumSignificantDigits = minimumSignificantDigits;
+        m_maximumSignificantDigits = maximumSignificantDigits;
+    }
+
     TriState useGrouping = intlBooleanOption(globalObject, options, Identifier::fromString(vm, "useGrouping"));
     RETURN_IF_EXCEPTION(scope, void());
     m_useGrouping = useGrouping != TriState::False;
 
-    m_signDisplay = intlOption<SignDisplay>(globalObject, options, Identifier::fromString(vm, "signDisplay"), { { "auto"_s, SignDisplay::Auto }, { "never"_s, SignDisplay::Never }, { "always"_s, SignDisplay::Always }, { "exceptZero"_s, SignDisplay::ExceptZero } }, "signDisplay must be either \"auto\", \"never\", \"always\", or \"exceptZero\""_s, SignDisplay::Auto);
-    RETURN_IF_EXCEPTION(scope, void());
-
-    CString dataLocaleWithExtensions = makeString(resolved.dataLocale, "-u-nu-", m_numberingSystem).utf8();
-    dataLogLnIf(IntlNumberFormatInternal::verbose, "dataLocaleWithExtensions:(", dataLocaleWithExtensions , ")");
-
-    // Options are obtained. Configure formatter here.
-
-#if HAVE(ICU_U_NUMBER_FORMATTER)
-    // Constructing ICU Number Skeletons to configure UNumberFormatter.
-    // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md
-
-    StringBuilder skeletonBuilder;
-    skeletonBuilder.appendLiteral("rounding-mode-half-up");
-
-    switch (m_style) {
-    case Style::Decimal:
-        // No skeleton is needed.
-        break;
-    case Style::Percent:
-        skeletonBuilder.appendLiteral(" percent scale/100");
-        break;
-    case Style::Currency: {
-        skeletonBuilder.appendLiteral(" currency/");
-        skeletonBuilder.append(currency);
-
-        // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#unit-width
-        switch (m_currencyDisplay) {
-        case CurrencyDisplay::Code:
-            skeletonBuilder.appendLiteral(" unit-width-iso-code");
-            break;
-        case CurrencyDisplay::Symbol:
-            // Default option. Do not specify unit-width.
-            break;
-        case CurrencyDisplay::NarrowSymbol:
-            skeletonBuilder.appendLiteral(" unit-width-narrow");
-            break;
-        case CurrencyDisplay::Name:
-            skeletonBuilder.appendLiteral(" unit-width-full-name");
-            break;
-        }
-        break;
-    }
-    case Style::Unit: {
-        // The measure-unit stem takes one required option: the unit identifier of the unit to be formatted.
-        // The full unit identifier is required: both the type and the subtype (for example, length-meter).
-        // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#unit
-        skeletonBuilder.appendLiteral(" measure-unit/");
-        auto numeratorUnit = wellFormedUnit->numerator;
-        skeletonBuilder.append(numeratorUnit.type, '-', numeratorUnit.subType);
-        if (auto denominatorUnitValue = wellFormedUnit->denominator) {
-            auto denominatorUnit = denominatorUnitValue.value();
-            skeletonBuilder.appendLiteral(" per-measure-unit/");
-            skeletonBuilder.append(denominatorUnit.type, '-', denominatorUnit.subType);
-        }
-
-        // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#unit-width
-        switch (m_unitDisplay) {
-        case UnitDisplay::Short:
-            skeletonBuilder.appendLiteral(" unit-width-short");
-            break;
-        case UnitDisplay::Narrow:
-            skeletonBuilder.appendLiteral(" unit-width-narrow");
-            break;
-        case UnitDisplay::Long:
-            skeletonBuilder.appendLiteral(" unit-width-full-name");
-            break;
-        }
-        break;
-    }
-    }
-
-    // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#integer-width
-    skeletonBuilder.appendLiteral(" integer-width/");
-    skeletonBuilder.append((WTF::ICU::majorVersion() >= 67) ? '*' : '+'); // Prior to ICU 67, use the symbol + instead of *.
-    for (unsigned i = 0; i < m_minimumIntegerDigits; ++i)
-        skeletonBuilder.append('0');
-
-    switch (m_roundingType) {
-    case IntlRoundingType::FractionDigits: {
-        // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#fraction-precision
-        skeletonBuilder.append(" .");
-        for (unsigned i = 0; i < m_minimumFractionDigits; ++i)
-            skeletonBuilder.append('0');
-        for (unsigned i = 0; i < m_maximumFractionDigits - m_minimumFractionDigits; ++i)
-            skeletonBuilder.append('#');
-        break;
-    }
-    case IntlRoundingType::SignificantDigits: {
-        // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#significant-digits-precision
-        skeletonBuilder.append(' ');
-        for (unsigned i = 0; i < m_minimumSignificantDigits; ++i)
-            skeletonBuilder.append('@');
-        for (unsigned i = 0; i < m_maximumSignificantDigits - m_minimumSignificantDigits; ++i)
-            skeletonBuilder.append('#');
-        break;
-    }
-    case IntlRoundingType::CompactRounding:
-        // Do not set anything.
-        break;
-    }
-
-    // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#notation
-    switch (m_notation) {
-    case IntlNotation::Standard:
-        break;
-    case IntlNotation::Scientific:
-        skeletonBuilder.appendLiteral(" scientific");
-        break;
-    case IntlNotation::Engineering:
-        skeletonBuilder.appendLiteral(" engineering");
-        break;
-    case IntlNotation::Compact:
-        switch (m_compactDisplay) {
-        case CompactDisplay::Short:
-            skeletonBuilder.appendLiteral(" compact-short");
-            break;
-        case CompactDisplay::Long:
-            skeletonBuilder.appendLiteral(" compact-long");
-            break;
-        }
-        break;
-    }
-
-    // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#sign-display
-    // CurrencySign's accounting is a part of SignDisplay in ICU.
-    bool useAccounting = (m_style == Style::Currency && m_currencySign == CurrencySign::Accounting);
-    switch (m_signDisplay) {
-    case SignDisplay::Auto:
-        if (useAccounting)
-            skeletonBuilder.appendLiteral(" sign-accounting");
-        else
-            skeletonBuilder.appendLiteral(" sign-auto");
-        break;
-    case SignDisplay::Never:
-        skeletonBuilder.appendLiteral(" sign-never");
-        break;
-    case SignDisplay::Always:
-        if (useAccounting)
-            skeletonBuilder.appendLiteral(" sign-accounting-always");
-        else
-            skeletonBuilder.appendLiteral(" sign-always");
-        break;
-    case SignDisplay::ExceptZero:
-        if (useAccounting)
-            skeletonBuilder.appendLiteral(" sign-accounting-except-zero");
-        else
-            skeletonBuilder.appendLiteral(" sign-except-zero");
-        break;
-    }
-
-    if (!m_useGrouping)
-        skeletonBuilder.appendLiteral(" group-off");
-
-    String skeleton = skeletonBuilder.toString();
-    dataLogLnIf(IntlNumberFormatInternal::verbose, skeleton);
-    StringView skeletonView(skeleton);
-    UErrorCode status = U_ZERO_ERROR;
-    m_numberFormatter = std::unique_ptr<UNumberFormatter, UNumberFormatterDeleter>(unumf_openForSkeletonAndLocale(skeletonView.upconvertedCharacters().get(), skeletonView.length(), dataLocaleWithExtensions.data(), &status));
-    if (U_FAILURE(status)) {
-        throwTypeError(globalObject, scope, "Failed to initialize NumberFormat"_s);
-        return;
-    }
-#else
     UNumberFormatStyle style = UNUM_DEFAULT;
     switch (m_style) {
     case Style::Decimal:
@@ -547,48 +280,19 @@ void IntlNumberFormat::initializeNumberF
         case CurrencyDisplay::Symbol:
             style = UNUM_CURRENCY;
             break;
-        case CurrencyDisplay::NarrowSymbol:
-            throwTypeError(globalObject, scope, "Failed to initialize NumberFormat since used feature is not supported in the linked ICU version"_s);
-            return;
         case CurrencyDisplay::Name:
             style = UNUM_CURRENCY_PLURAL;
             break;
+        default:
+            ASSERT_NOT_REACHED();
         }
-        switch (m_currencySign) {
-        case CurrencySign::Standard:
-            break;
-        case CurrencySign::Accounting:
-            throwTypeError(globalObject, scope, "Failed to initialize NumberFormat since used feature is not supported in the linked ICU version"_s);
-            return;
-        }
-        break;
-    case Style::Unit:
-        throwTypeError(globalObject, scope, "Failed to initialize NumberFormat since used feature is not supported in the linked ICU version"_s);
-        return;
-    }
-
-    switch (m_notation) {
-    case IntlNotation::Standard:
-        break;
-    case IntlNotation::Scientific:
-    case IntlNotation::Engineering:
-    case IntlNotation::Compact:
-        throwTypeError(globalObject, scope, "Failed to initialize NumberFormat since used feature is not supported in the linked ICU version"_s);
-        return;
-    }
-
-    switch (m_signDisplay) {
-    case SignDisplay::Auto:
         break;
-    case SignDisplay::Never:
-    case SignDisplay::Always:
-    case SignDisplay::ExceptZero:
-        throwTypeError(globalObject, scope, "Failed to initialize NumberFormat since used feature is not supported in the linked ICU version"_s);
-        return;
+    default:
+        ASSERT_NOT_REACHED();
     }
 
     UErrorCode status = U_ZERO_ERROR;
-    m_numberFormat = std::unique_ptr<UNumberFormat, UNumberFormatDeleter>(unum_open(style, nullptr, 0, dataLocaleWithExtensions.data(), nullptr, &status));
+    m_numberFormat = std::unique_ptr<UNumberFormat, UNumberFormatDeleter>(unum_open(style, nullptr, 0, m_locale.utf8().data(), nullptr, &status));
     if (U_FAILURE(status)) {
         throwTypeError(globalObject, scope, "failed to initialize NumberFormat"_s);
         return;
@@ -601,58 +305,40 @@ void IntlNumberFormat::initializeNumberF
             return;
         }
     }
-
-    switch (m_roundingType) {
-    case IntlRoundingType::FractionDigits:
+    if (!m_minimumSignificantDigits) {
         unum_setAttribute(m_numberFormat.get(), UNUM_MIN_INTEGER_DIGITS, m_minimumIntegerDigits);
         unum_setAttribute(m_numberFormat.get(), UNUM_MIN_FRACTION_DIGITS, m_minimumFractionDigits);
         unum_setAttribute(m_numberFormat.get(), UNUM_MAX_FRACTION_DIGITS, m_maximumFractionDigits);
-        break;
-    case IntlRoundingType::SignificantDigits:
+    } else {
         unum_setAttribute(m_numberFormat.get(), UNUM_SIGNIFICANT_DIGITS_USED, true);
         unum_setAttribute(m_numberFormat.get(), UNUM_MIN_SIGNIFICANT_DIGITS, m_minimumSignificantDigits);
         unum_setAttribute(m_numberFormat.get(), UNUM_MAX_SIGNIFICANT_DIGITS, m_maximumSignificantDigits);
-        break;
-    case IntlRoundingType::CompactRounding:
-        throwTypeError(globalObject, scope, "Failed to initialize NumberFormat since used feature is not supported in the linked ICU version"_s);
-        return;
     }
     unum_setAttribute(m_numberFormat.get(), UNUM_GROUPING_USED, m_useGrouping);
     unum_setAttribute(m_numberFormat.get(), UNUM_ROUNDING_MODE, UNUM_ROUND_HALFUP);
-#endif
 }
 
 // https://tc39.es/ecma402/#sec-formatnumber
 JSValue IntlNumberFormat::format(JSGlobalObject* globalObject, double value) const
 {
+    ASSERT(m_numberFormat);
+
     VM& vm = globalObject->vm();
     auto scope = DECLARE_THROW_SCOPE(vm);
 
     Vector<UChar, 32> buffer;
-#if HAVE(ICU_U_NUMBER_FORMATTER)
-    ASSERT(m_numberFormatter);
-    UErrorCode status = U_ZERO_ERROR;
-    auto formattedNumber = std::unique_ptr<UFormattedNumber, UFormattedNumberDeleter>(unumf_openResult(&status));
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "Failed to format a number."_s);
-    unumf_formatDouble(m_numberFormatter.get(), value, formattedNumber.get(), &status);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "Failed to format a number."_s);
-    status = callBufferProducingFunction(unumf_resultToString, formattedNumber.get(), buffer);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "Failed to format a number."_s);
-#else
-    ASSERT(m_numberFormat);
     auto status = callBufferProducingFunction(unum_formatDouble, m_numberFormat.get(), value, buffer, nullptr);
     if (U_FAILURE(status))
         return throwTypeError(globalObject, scope, "Failed to format a number."_s);
-#endif
+
     return jsString(vm, String(buffer));
 }
 
 // https://tc39.es/ecma402/#sec-formatnumber
 JSValue IntlNumberFormat::format(JSGlobalObject* globalObject, JSBigInt* value) const
 {
+    ASSERT(m_numberFormat);
+
     VM& vm = globalObject->vm();
     auto scope = DECLARE_THROW_SCOPE(vm);
 
@@ -663,24 +349,10 @@ JSValue IntlNumberFormat::format(JSGloba
     auto* rawString = reinterpret_cast<const char*>(string.characters8());
 
     Vector<UChar, 32> buffer;
-#if HAVE(ICU_U_NUMBER_FORMATTER)
-    ASSERT(m_numberFormatter);
-    UErrorCode status = U_ZERO_ERROR;
-    auto formattedNumber = std::unique_ptr<UFormattedNumber, UFormattedNumberDeleter>(unumf_openResult(&status));
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "Failed to format a BigInt."_s);
-    unumf_formatDecimal(m_numberFormatter.get(), rawString, string.length(), formattedNumber.get(), &status);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "Failed to format a BigInt."_s);
-    status = callBufferProducingFunction(unumf_resultToString, formattedNumber.get(), buffer);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "Failed to format a BigInt."_s);
-#else
-    ASSERT(m_numberFormat);
     auto status = callBufferProducingFunction(unum_formatDecimal, m_numberFormat.get(), rawString, string.length(), buffer, nullptr);
     if (U_FAILURE(status))
         return throwTypeError(globalObject, scope, "Failed to format a BigInt."_s);
-#endif
+
     return jsString(vm, String(buffer));
 }
 
@@ -693,8 +365,6 @@ ASCIILiteral IntlNumberFormat::styleStri
         return "percent"_s;
     case Style::Currency:
         return "currency"_s;
-    case Style::Unit:
-        return "unit"_s;
     }
     ASSERT_NOT_REACHED();
     return ASCIILiteral::null();
@@ -707,8 +377,6 @@ ASCIILiteral IntlNumberFormat::currencyD
         return "code"_s;
     case CurrencyDisplay::Symbol:
         return "symbol"_s;
-    case CurrencyDisplay::NarrowSymbol:
-        return "narrowSymbol"_s;
     case CurrencyDisplay::Name:
         return "name"_s;
     }
@@ -716,76 +384,6 @@ ASCIILiteral IntlNumberFormat::currencyD
     return ASCIILiteral::null();
 }
 
-ASCIILiteral IntlNumberFormat::notationString(IntlNotation notation)
-{
-    switch (notation) {
-    case IntlNotation::Standard:
-        return "standard"_s;
-    case IntlNotation::Scientific:
-        return "scientific"_s;
-    case IntlNotation::Engineering:
-        return "engineering"_s;
-    case IntlNotation::Compact:
-        return "compact"_s;
-    }
-    ASSERT_NOT_REACHED();
-    return ASCIILiteral::null();
-}
-
-ASCIILiteral IntlNumberFormat::currencySignString(CurrencySign currencySign)
-{
-    switch (currencySign) {
-    case CurrencySign::Standard:
-        return "standard"_s;
-    case CurrencySign::Accounting:
-        return "accounting"_s;
-    }
-    ASSERT_NOT_REACHED();
-    return ASCIILiteral::null();
-}
-
-ASCIILiteral IntlNumberFormat::unitDisplayString(UnitDisplay unitDisplay)
-{
-    switch (unitDisplay) {
-    case UnitDisplay::Short:
-        return "short"_s;
-    case UnitDisplay::Narrow:
-        return "narrow"_s;
-    case UnitDisplay::Long:
-        return "long"_s;
-    }
-    ASSERT_NOT_REACHED();
-    return ASCIILiteral::null();
-}
-
-ASCIILiteral IntlNumberFormat::compactDisplayString(CompactDisplay compactDisplay)
-{
-    switch (compactDisplay) {
-    case CompactDisplay::Short:
-        return "short"_s;
-    case CompactDisplay::Long:
-        return "long"_s;
-    }
-    ASSERT_NOT_REACHED();
-    return ASCIILiteral::null();
-}
-
-ASCIILiteral IntlNumberFormat::signDisplayString(SignDisplay signDisplay)
-{
-    switch (signDisplay) {
-    case SignDisplay::Auto:
-        return "auto"_s;
-    case SignDisplay::Never:
-        return "never"_s;
-    case SignDisplay::Always:
-        return "always"_s;
-    case SignDisplay::ExceptZero:
-        return "exceptZero"_s;
-    }
-    ASSERT_NOT_REACHED();
-    return ASCIILiteral::null();
-}
-
 // https://tc39.es/ecma402/#sec-intl.numberformat.prototype.resolvedoptions
 JSObject* IntlNumberFormat::resolvedOptions(JSGlobalObject* globalObject) const
 {
